{$A+,B-,E-,F-,G+,I-,N-,O-,V-,X+ }

{ -- vu ??? --^^ !!! }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

{$M 30000, 163840, 327680 }

Program VTex;

Uses Dos,Crt,Colors,Video60,VdtDisp,EmulM2;


Var ExInt1C  : Pointer;
    SaveExit : Pointer;
    C18      : Longint;


{$IFOPT R+ } {$DEFINE RON } {$R-} {$ENDIF }
{$IFOPT S+ } {$DEFINE SON } {$S-} {$ENDIF }

Procedure NewInt1C; Assembler;
Asm
 PUSH AX
 PUSH DS

 MOV  AX, SEG @DATA
 MOV  DS, AX

 ADD  [WORD PTR C18], 1
 ADC  [WORD PTR C18+2], 0

 PUSHF
 CALL [ExInt1C]

 POP  DS
 POP  AX
 IRET
End;

{$IFDEF SON } {$S+ } {$UNDEF SON } {$ENDIF }
{$IFDEF RON } {$R+ } {$UNDEF RON } {$ENDIF }


Function GetC18 : Longint; Assembler;
Asm
    CLI
    MOV  AX, [WORD PTR C18]
    MOV  DX, [WORD PTR C18+2]
    STI
End;



Procedure DisposeC18; Far;
Begin
 ExitProc := SaveExit;
 SetIntVec($1C,ExInt1C);
End;


Procedure InstallC18;
Begin
  C18 := 1;   { et non 0 }

  GetIntVec($1C,ExInt1C);
  SetIntVec($1C,@NewInt1C);

  SaveExit := ExitProc;
  ExitProc := @DisposeC18;
End;




Const
      VideoMode : Byte = VMODE_640; { VMODE_VGA; }
      Grey      : Boolean = TRUE;
      EgaLight  : Boolean = FALSE;
      Neige     : Boolean = FALSE;


      SIZEMAXFILE = 8192;

      POSY      = 1; { 1; }
      POSX      = 21; { 1; }

Var DRCSDetect : Boolean;

Procedure VideoInit;
Var vm  : Byte;
Begin
  { Init Video }
  vm := OpenVideoSys(VideoMode,Neige,Grey,EGALight);
  VideoMode := vm;
End;


Procedure VideoDone;
Begin
 CloseVideoSys;
End;





Const
     RIEN        = 32; { 250; }
     CarGraphik  = 240;
     BasePanel   = Trait+Stable;


Procedure NoEgaVdtChar( c : Char; x, y : Byte; Attr : Word;
                        Reverse, CadreEvol : Boolean );
Var pix : DtScr_Rec;
Begin
 If (y=0) And (x>=36) And (x<=38) Then
  Begin { spcial ! }
   If (x=36) Or (x=37) Then
    Begin
     pix.car := Byte(' ');
     pix.att := TNet;
    End
   Else
    Begin
     pix.car := Byte('C');
     pix.att := CRvs;
    End;
  End
 Else
  If Reverse Then
   Begin
     if c=#0 then
       begin
         pix.car := RIEN;
         pix.att := CRienOut;
       end
     else
       begin
         if (Attr and Graphik)=0 then pix.car := Byte(c)
         else pix.car := CarGraphik;
         pix.att := CToutOut;
       end;
   End
  Else
   If CadreEvol Then
    Begin
     if c=#0 then
      Begin
       pix.car := RIEN;
       pix.att := CCadreEvol;
      End
     else
      Begin
       If Attr And DRCS=0 Then pix.att := CCadreEvol
       Else pix.att := CCadreEvolDRCS;
       if (Attr and Graphik)=0 then pix.car := Byte(c)
       Else pix.car := CarGraphik;
      End;
    End
   Else
    Begin
     if c=#0 then
       begin
         pix.car := RIEN;
         pix.att := CRien;
       end
     else
       begin
         if (Attr and Graphik)=0 then pix.car := Byte(c)
         else pix.car := CarGraphik;
         If attr And DRCS=0 Then pix.att := CTout
         Else pix.att := CDRCS;
       End;
    End;
 WrtDt(Byte(pix.car),POSX+x,POSY+y,pix.att);
End;

Procedure EgaVdtChar( c : Char; x, y : Byte; Attr : Word; Reverse : Boolean; Ext : Byte );
Var pix : DtScr_Rec;
    t, f : Byte;
    more : word;
    _a_  : Word;
Begin
 _a_  := Attr;          { conserver l'original...}
 more := 0;
 If (y=0) And (x>=36) And (x<=38) Then
  Begin { spcial ! }
   If c=#0 Then Attr := BasePanel;
   If (x=36) Or (x=37) Then
    Begin
     pix.car := Byte(' ');
     pix.att := ((Attr And 56) Shl 1) Or 7;
    End
   Else
    Begin
     pix.car := Byte('C');
     pix.att := 112 Or ((Attr And 56) Shr 3);
    End;
  End
 Else
  if c=#0 then
    begin
      pix.car := RIEN;
      pix.att := CRien;
    end
  else
    begin
      if (Attr and Graphik)=0 then pix.car := Byte(c)
      else pix.car := CarGraphik;
      If attr And DRCS=0 Then
       Begin
        If (Attr And (Inverse+Graphik)=Inverse) Then
          Begin
            Attr := (Attr And Not(7+56)) Or
                    ((Attr And 7) Shl 3) Or
                    ((Attr And 56) Shr 3);
            pix.att := CRvs;  { en attendant... }
          End
        Else pix.att := CTout;

        pix.att := (Attr And 7)+((Attr And 56) Shl 1);
       End
      Else
       Begin
        pix.Att := CDRCS;
        If (Attr And (Inverse+Graphik)=Inverse) Then
         Begin
          Attr := (Attr And Not(7+56)) Or
                  ((Attr And 7) Shl 3) Or
                  ((Attr And 56) Shr 3);
         End;

          pix.att := (Attr And 7)+((Attr And 56) Shl 1);

          If (c<>#$20) And (c<>#$7F) (* And ((Attr And AttComplement)=0) *) Then
           Begin
            If Attr And Graphik=0 Then pix.Car := MatGP0+(Byte(c)-32)
            Else pix.Car := MatGP1+(Byte(c)-32);

            pix.Att := pix.Att Or (128+8);
           End
          Else pix.Car := Byte(c);
       End;

      If ((Attr And (Graphik+DRCS))=Graphik) Then
       Begin
        If Attr And Disjoint<>0 Then
         Begin
          If c<Char(32+64) Then
           pix.Car := MatG1D+((Byte(c)-32) And 63)
          Else pix.Car := MatG1D+((Byte(c)-64) And 63);
         End
        Else
         Begin
          If c>=#$40 Then
           Begin
            pix.Car := MatG1+(((Byte(c)-32) And 31) Xor 31);
            pix.att := (pix.att And Not(112+7)) Or
                       (((pix.att And 112) Shr 4)+
                        ((pix.att And 7) Shl 4));
           End
          Else pix.Car := MatG1+((Byte(c)-32) And 31);
         End;

        pix.Att := pix.Att Or 128;

       End;
    end;

 If Reverse Then
  Begin
   f := (pix.att And 112) Shr 4;
   t := (pix.att And 7);
   f := f xor 7;
   t := t xor 7;
   pix.att := (pix.att And Not(112+7)) Or t Or (f Shl 4);
  End;

 If (_a_ And Graphik)=0 Then
  Begin
   If ((_a_ And (Taille_Large+Taille_Haute))<>0) Then
    Begin
     If (Ext=Complement_Null) Then
      Begin
       If (_a_ And (Taille_Large+Taille_Haute))=Taille_Large+Taille_Haute Then
        more := more Or 11
       Else
        If (_a_ And Taille_Large)<>0 Then more := more Or 1
        Else more := 6;
       If (_a_ And (Souligne+Delim))=Souligne Then more := more Or 128;
      End
     Else
      If (Ext=Complement_Haut) Then
       Begin
        if (_a_ And Taille_Large)<>0 Then more := more Or 3
        else more := more Or 2;
       End
      Else
       If (Ext=Complement_Droite) Then
        Begin
         if (_a_ And Taille_Haute)<>0 Then more := more Or 15
         else more := more Or 5;
         If (_a_ And (Souligne+Delim))=Souligne Then more := more Or 128;
        End
       Else
        Begin
         more := more Or 7;
        End;
    End
   Else If (_a_ And (Souligne+Delim))=Souligne Then more := more Or 128;
  End;

 If ((pix.att And 112) Shr 4)=(pix.att And 7) Then
  Begin { curseur invisible !!! }
   pix.car := $20;   { remplac par ca ! }
   pix.att := pix.att Xor 7;
   if (more And 128)<>0 Then more := more And Not(128);
   { ci-dessus, on desactive le soulignement qui ne doit pas s'afficher! }
  End;

 WrtX(Byte(pix.car),POSX+x,POSY+y,pix.att,more);
End;



Procedure _AffVdtChar( c : Char; x, y : Byte; Attr : Word; Ext : Byte );
Begin
 If VideoEGA Then EgaVdtChar(c,x,y,Attr,FALSE,Ext)
 Else NoEgaVdtChar(c,x,y,Attr,FALSE,FALSE);
End;


procedure AffLnShow( Var Ram : VDispRam; Var Ext : VDispExt; iY : Byte );
var iX : Byte;
    c  : VDispRamEl;
begin
 for iX := 0 to ScreenLong-1 do
   begin
     c := Ram[iY,iX];
     _AffVdtChar(c.Car,iX,iY,c.Att,Ext[iY,iX]);
  end;
end;


procedure AffAllLnShow( Var Ram : VDispRam; Var Ext : VDispExt );
var iY : Byte;
    iX : Byte;
    c  : VDispRamEl;
begin
 for iY := 0 to ScreenHigh-1 do
  for iX := 0 to ScreenLong-1 do
    begin
      c := Ram[iY,iX];
      _AffVdtChar(c.Car,iX,iY,c.Att,Ext[iY,iX]);
   end;
end;








Procedure EmulToScreen( Ram : PVDispRam; Ext : PVDispExt; x, y, lg, ht : Byte ); Far;
Var iX, iY : Byte;
    c : Char;
    a : Word;
Begin
 If (Ram<>NIL) Then
  Begin
   For iY := y To y+Ht-1 Do
    For iX := x To x+Lg-1 Do
     Begin
      c := Ram^[iY,iX].Car;
      a := Ram^[iY,iX].Att;
      If (c<>#0) And (a And DRCS<>0) Then DRCSDetect := TRUE;
      _AffVdtChar(c,iX,iY,a,Ext^[iY,iX]);
     End;
  End;
End;


Procedure EmulToScreenScroll( Ram : PVDispRam; Ext : PVDispExt; y : Byte; Down : Boolean ); Far;
Var Zn  : Zn_Rec;
Begin
 If (Ram<>NIL) Then
  If Down Then
   Begin
    Zn.X  := POSX;
    Zn.Y  := POSY+Y;
    Zn.Lg := ScreenLong;
    Zn.Ht := ScreenHigh-Y;
    ZnDn(Zn,1,0);
    EmulToScreen(Ram,Ext,0,y,ScreenLong,1);
   End
  Else
   Begin
    Zn.X  := POSX;
    Zn.Y  := POSY+Y;
    Zn.Lg := ScreenLong;
    Zn.Ht := ScreenHigh-Y;
    ZnUp(Zn,1,0);
    EmulToScreen(Ram,Ext,0,ScreenHigh-1,ScreenLong,1);
   End;
End;




Procedure RefreshEmulCur( Var E : EmulRec );
Begin
 CurPos(POSX+E.Situ.X,POSY+E.Situ.Y);
(*
 ECurX := E.Situ.X;
 ECurY := E.Situ.Y;
*)
End;

Procedure AffichePage( Var E2 : EmulRec; Var f : File; UseDRCS : Boolean; Slow : Boolean );
Var max : Word;
    i : Word;
    buf : Array[1..128] Of Char;
    lgbuf : Word;
Begin
 { Ok. }
   max := 0;
   While Not(Eof(f)) And (max<SIZEMAXFILE) Do
    Begin
     BlockRead(f,buf,SizeOf(buf),lgbuf);
     For i := 1 To lgbuf Do
      Begin
       EmulM2.Emul(E2,buf[i]);
       If Slow Then
        Begin
         delay(8);
         If KeyPressed Then
          Begin
           If ReadKey=#0 Then ReadKey;
           If Slow Then Slow := FALSE
           Else Break;
          End;
        End;
      End;
     inc(max,lgbuf);
    End;
End;


Procedure EmulStr( Var E2 : EmulRec; Texte : String );
Var i : Byte;
Begin
 For i := 1 To Length(Texte) Do EmulM2.Emul(E2,Char(Texte[i]));
End;

Function Val2Str( x : Longint; Surf : Byte ) : String;
Var s : String[12];
    i : Byte;
Begin
 Str(x:Surf,s);
 i := 1;
 While (s[i]=' ') Do
  Begin
   s[i] := '0';
   Inc(i);
  End;
 Val2Str := s;
End;


Procedure WrtXLStr( s : String; x, y : Word; c : Byte );
Var i : Word;
Begin
 For  i:=1 To Length(s) Do
  Begin
   WrtX(Byte(s[i]),x,y,c,1);
   Inc(x);
   WrtX(Byte(s[i]),x,y,c,5);
   Inc(x);
  End;
End;


Const PX        = 45;
      PY        = 27;
      PCADRE    = 12;
      PCP       = $0D;  { $1D; }
      PP        = $0E;  { $1E; }
      ScrHi     = 35;
      AX        = 0;
      AY        = POSY+ScreenHigh+1;
      ALG       = 80;
      AHT       = 1;
      AA        = $07; { $17; }

      MX        = 0;
      MY        = 31;

Procedure PresenteSoft;
Begin
 CurOff;

 FillZc(0,0,80,ScrHi,32,$1D); { 176,$1D); }

 CdrZc(POSX-1,POSY-1,ScreenLong+2,ScreenHigh+2,CdrTab[1],PCADRE);

 ClrZc(MX,MY,25,4,PCP);
 CdrZc(MX,MY,25,4,CdrTab[1],PCADRE);
 WrtX(Byte('V'),MX+1,MY+1,$70,1);
 WrtX(Byte('V'),MX+2,MY+1,$50,5);
 WrtX(Byte('T'),MX+3,MY+1,$70,1);
 WrtX(Byte('T'),MX+4,MY+1,$50,5);
 WrtX(Byte('E'),MX+5,MY+1,$70,1);
 WrtX(Byte('E'),MX+6,MY+1,$50,5);
 WrtX(Byte('X'),MX+7,MY+1,$70,1);
 WrtX(Byte('X'),MX+8,MY+1,$50,5);
 WrtScr('(C) 1995 Thierry JAOUEN',MX+1,MY+2,PCP);

 ClrZc(PX,PY,35,8,PCP);
 CdrZc(PX,PY,35,8,CdrTab[1],PCADRE);

 WrtScr('[PgDn]  Page suivante',PX+1,PY+1,PP);
 WrtScr('[PgUp]  Page prcdente',PX+1,PY+2,PP);
 WrtScr('[Home]  Revoir la page',PX+1,PY+3,PP);
 WrtScr('[Ctrl]+[Home] Revoir  1200 bauds',PX+1,PY+4,PP);
 WrtScr('[F1]  Couleurs/Gris',PX+1,PY+5,PP);
 WrtScr('[F10]  Fin',PX+1,PY+6,PP);
End;


(**********************************************)

Const
     TxtCoul        : array [0..7] of string [9]
                      = ( ' Noir    ',' Bleu    ',' Rouge   ',' Magenta ',
                          ' Vert    ',' Cyan    ',' Jaune   ',' Blanc   ');
     TxtTail        : array [0..3] of string [9]
                      = ( ' Normale ',' Haute   ',' Large   ',' Double  ');

function InvGraphCorrector( val : byte) : byte;
{ effectue l'operation inverse de GraphCorrector, c-a-d que l'on restitue }
{ la valeur graphique de calcul (0-63) }
begin
  val := val and 127;
  if val>=96 then dec(val,64)
  else
    if val=95 then val := 63
    else dec(val,32);
  InvGraphCorrector := val;
end;

Function Hexa( b : Byte ) : String;
Var s : Array[1..2] Of Char;
    z : Byte;
Begin
 z := (b Shr 4) And 15;
 If z<10 Then s[1] := Char(Byte('0')+z)
 Else s[1] := Char(Byte('A')-10+z);

 z := b And 15;
 If z<10 Then s[2] := Char(Byte('0')+z)
 Else s[2] := Char(Byte('A')-10+z);

 Hexa := s;
End;




Const XShow = 0;
      YShow = 2;
      CShow = $07;

      XMat = (XShow+1);
      YMat = (YShow+3);


Procedure ShowMat( Var Mat : MinMatrice; x, y, Attr : Byte );
Var i, j : Byte;
    h, l : Byte;
    hh, ll : Boolean;
    c    : Char;
    s    : String[8];
Begin
 s[0] := #8;
 For i := 0 To 4 Do
  Begin
   h := Mat[i*2];
   l := Mat[i*2+1];
   For j := 7 Downto 0 Do
    Begin
     hh := (h And (1 Shl j))<>0;
     ll := (l And (1 Shl j))<>0;
     If hh Then
      If ll Then c := '' Else c := ''
     Else
      If ll Then c := '' Else c := ' ';
     s[8-j] := c;
    End;
   WrtScr(s,x,y+i,Attr);
  End;
End;


Procedure MatGraphik(gra: byte; Var d : MinMatrice );
Var Mat : MinMatrice;
    x   : Byte;
    i   : Byte;
Begin
 x := ((gra Shr 1) And 1)*15+(gra And 1)*240;
 For i := 0 To 2 Do Mat[i] := x;

 x := ((gra Shr 3) And 1)*15+((gra Shr 2) And 1)*240;

 For i := 3 To 6 Do Mat[i] := x;

 x := ((gra Shr 5) And 1)*15+((gra Shr 4) And 1)*240;

 For i := 7 To 9 Do Mat[i] := x;

 d := Mat;
End;


Function GWhat( Car : Char; Attr : Word;
                Var RamDRCS : VDispRamDRCS;
                Var mm : MinMatrice ) : String;
Var s : String[1];
    d : String[3];
    c : Byte;
    g : Byte;
Begin
 If (Car=#0) Or ((Attr And AttComplement)<>0) Then
  Begin
   mm := JeuG0[0];
   GWhat := '';
  End
 Else
  If Attr And Graphik<>0 Then
   Begin
    If  (Attr And DRCS=0) Then
     Begin
      MatGraphik( InvGraphCorrector(Byte(car)), mm );
      GWhat := 'G1 '+Hexa(Byte(car));
     End
    Else
     Begin
      If (Car=#32) Or (Car=#127) Then
       Begin
        MatGraphik( InvGraphCorrector(Byte(car)), mm );
       End
      Else mm := RamDRCS[1,Byte(Car)-Byte('!')];
      GWhat := 'G''1 '+Hexa(Byte(car));
     End;
   End
  Else
   Begin
    s := Car;
    IbmVdt(s,d);
    If d='' Then d := ' ';
    If d[1]>=#32 Then
     Begin
      If Attr And DRCS=0 Then
       Begin
        mm := JeuG0[Byte(d[1])-32];
        GWhat := 'G0 '+Hexa(Byte(d[1]));
       End
      Else
       Begin
        If (Car=#32) Or (Car=#127) Then mm := JeuG0[Byte(d[1])-32]
        Else mm := RamDRCS[0,Byte(d[1])-Byte('!')];
        GWhat := 'G''0 '+Hexa(Byte(d[1]));
       End;
     End
    Else
     Begin
      c := InRang(Accent,5,Byte(d[2]));
      If c>0 Then
       Begin
        g := InRang(Voyelle,5,Byte(d[3]));
        If g>0 Then mm := JeuG2B[((c-1)*5)+(g-1)]
        Else
         If d[3]='c' Then mm := JeuG2B[C_CEDILLE]
         Else mm := JeuG0[Byte(d[3])-32];
         (*
          If d[3]='C' Then mm := JeuG0[Byte('C')-32]
          Else mm := JeuG0[0];
         *)
        GWhat := 'G2 '+Hexa(Byte(d[2]))+' '+Hexa(Byte(d[3]));
       End
      Else
       Begin
        c := InRang(VdtDisp.SS2,LgG2,Byte(d[2]));
        If c>0 Then mm := JeuG2[c-1] Else mm := JeuG0[0];
        GWhat := 'G2 '+Hexa(Byte(d[2]));
       End;
     End;
   End;
End;


Procedure ShowAttr( Attr : Word );
Var s : String[9];
Begin
 WrtScr(TxtCoul[Attr And Trait],XShow+10,YShow+3,CShow);
 WrtScr(TxtCoul[(Attr And Fond) Shr 3],XShow+10,YShow+4,CShow);
 WrtScr(TxtTail[(Attr And Taille) Shr 6],XShow+10,YShow+5,CShow);
 If Attr And Inverse<>0 Then s := 'Inve' Else s := '    ';
 If Attr And Stable=0 Then s := s+' Clig' Else s := s+'     ';
 WrtScr(s,XShow+10,YShow+6,CShow);
 If Attr And Souligne<>0 Then
  If Attr And Graphik=0 Then s := 'Soul' Else s := 'Disj'
 Else s := '    ';
 If Attr And Mask<>0 Then s := s+' Masq' Else s := s+'     ';
 WrtScr(s,XShow+10,YShow+7,CShow);
End;


Procedure ShowAttrRien;
Var i : Byte;
Begin
 For i := 3 To 7 Do WrtScr('         ',XShow+10,YShow+i,CShow);
End;


Procedure ShowCar( Var Em : EmulRec; Car : Char; Attr : Word );
Var s : String[20];
    m : MinMatrice;
    i : Byte;
Begin
 s := GWhat( Car, Attr, Em.DRCS^, m );
 If (Car=#0) Then s := 'VIDE'
 Else
  If ((Attr And AttComplement)<>0) Then s := 'COMPLEM.'
  Else
   If (Car=#$20) And (Attr And Delim<>0) Then s := s+' *';

 While Length(s)<8 Do s := s+' ';
 WrtScr(s,XMat,YMat-2,CShow);

 ShowMat(m,XMat,YMat,CPixel);

 If Car=#0 Then ShowAttrRien
 Else ShowAttr(Attr);
End;


Procedure ShowCarFond;
Var i : Byte;
Begin
 FillZc(XShow,YShow-2,20,11,$20,PCadre);
 CdrZc(XShow,YShow-2,20,11,CdrTab[1],PCADRE);

 WrtScr('Ĵ',XShow+0,YShow,PCadre);
 WrtScr('Ĵ',XShow+0,YShow+2,PCadre);

 For i := 3 To 8 Do
  Begin
   WrtScr('',XShow+9,YShow+i,PCadre);
  End;
 WrtDt(Byte(''),XShow+9,YShow+8,PCadre);
End;

Const FX = 62;
      FY = 0;
      FC = $07;
      FCS = $05;


Procedure AfficheName( Var Name : String; len : LongInt; num : Word; nbpage : Word );
Var Tmp : String;
    i   : Word;
    t   : Word;
Begin
 FillZc(FX,FY,18,5,Byte(' '),FC);
 CdrZc(FX,FY,18,5,CdrTab[1],PCADRE);
 WrtScr(Name,FX+1,FY+1,FC);
 If (len<=SIZEMAXFILE) Then
  Begin
   tmp := Val2Str(len,0)+' octets';
   WrtScr(tmp,FX+1,FY+2,FCS);
   t := len Div 12;
   Tmp := '('+Val2Str(t Div 10,0)+'.'+Val2Str(t Mod 10,0)+' s)';
   WrtScr(Tmp,FX+1,FY+3,FCS);
  End;
 tmp := Val2Str(num,4)+'/'+Val2Str(nbpage,4);
 WrtScr(tmp,FX+8,FY+4,$50);
End;

(**********************************************)

Function ShowPage( num : Word; nbpage: Word;
                   Var Rep : String;
                   Name : String; UseDRCS : Boolean ) : Word;
Var E2 : EmulRec;
    i : Word;
    f : File;
    Quit : Boolean;
    Next : Boolean;
    Key : Char;
    Funct : Boolean;
    Show : Boolean;
    NewPos : Boolean;
    tmp : String[100];
    cont : Word;
    Slow : Boolean;
    save_fm : Byte;
Begin
 ShowPage := $FFFF;     { par dfaut }

 { Prparer l'emulateur }


 New(E2.Ram);
 New(E2.Ext);
 If (E2.Ram=NIL) Or (E2.Ext=NIL) Then Exit;

 ClearRam(E2.Ram,E2.Ext);
 If UseDRCS Then
  Begin
   New(E2.DRCS);
   If E2.DRCS=NIL Then
    Begin
     Dispose(E2.Ram);
     E2.Ram := NIL;
     Exit;
    End;
   ClearRamDRCS(E2.DRCS);
  End
 Else E2.DRCS := NIL;

 Quit := FALSE;
 Next := FALSE;

 cont := num;

 Slow := FALSE;

 ShowCarFond;

 While Not(Quit) And Not(Next) Do
  Begin
   CurOff;

   Show := FALSE;

   InitEmul(E2,E2.Ram,E2.Ext,E2.DRCS);

   EmulStr(E2,#12#31'@A'#24#10);

   DRCSDetect := FALSE;


   save_fm := FileMode;         { sauve }
   FileMode := 0;               { Lecture seule }

   Assign(f,Rep+Name);
   Reset(f,1);

   FileMode := save_fm;         { restore }

   If IoResult=0 Then
    Begin
     AfficheName(Name,FileSize(f),num,nbpage);
     AffichePage(E2,f,TRUE,Slow);

     Close(f);
    End
   Else
    Begin
     EmulStr(E2,#31'DE!!! Je trouve plus la page !!!');
     tmp := tmp+'  ????';
     WrtScr(tmp,AX,AY,AA);
    End;

   If DRCSDetect And (UseDRCS) Then
    Begin
     LoadMatrice(E2.DRCS^[0],94,1,MatGP0+1);
     LoadMatrice(E2.DRCS^[1],94,1,MatGP1+1);
{     ResetVideoEGA; }
    End;

   NewPos := TRUE;
   CurOn;

   While Not(Quit) And Not(Next) And Not(Show) Do
    Begin
     If (NewPos) Then
      Begin
       RefreshEmulCur(E2);
       ShowCar(E2,E2.Ram^[E2.Situ.Y,E2.Situ.X].Car,E2.Ram^[E2.Situ.Y,E2.Situ.X].Att);
       Tmp := '  L:'+Val2Str(E2.Situ.Y,2)+' C:'+Val2Str(E2.Situ.X+1,2)+
              ' ['+Char(64+E2.Situ.Y)+Char(65+E2.Situ.X)+']  ';

       WrtScr(Tmp,XShow+1,YShow-1,$70);

       NewPos := FALSE;
      End;
     VideoSynchro(GetC18);

     If KeyPressed Then
      Begin
       Key := ReadKey;
       If Key=#0 Then
        Begin
         Funct := TRUE;
         Key := readKey;
        End
       Else Funct := FALSE;

       If Funct Then
        Begin
         Case Key Of
          #45, #16, #68 : Quit := TRUE;      { AltX AltQ ou F10 on sort }
          #81 : Begin
                 cont := num+1;                { PgDown suite }
                 Next := TRUE;
                End;
          #73 : Begin                          { PgUp prec... }
                 cont := num-1;
                 Next := TRUE;
                End;
          #71 : Begin
                 Show := TRUE;                 { Home Revoir viiiite }
                 Slow := FALSE;
                End;
          #119 : Begin                          { ctrl+home revoir lent }
                  Show := TRUE;
                  Slow := TRUE;
                 End;
          #59 :
           Begin
            If (Grey) Then FixPalCoVGA
            Else FixPalBWVGA;
            Grey := Not(Grey);
           End;
          #72 :
           Begin
            EmulM2.Emul(E2,#11);          { haut }
            NewPos := TRUE;
           End;
          #80 :
           Begin
            EmulM2.Emul(E2,#10);          { bas }
            NewPos := TRUE;
           End;
          #77 :
           Begin
            EmulM2.Emul(E2,#9);           { droite }
            NewPos := TRUE;
           End;
          #75 :
           Begin
            EmulM2.Emul(E2,#8);           { gauche }
            NewPos := TRUE;
           End;
         End;
        End
       Else
        Begin
         If Key<#128 Then
          Begin
           EmulM2.Emul(E2,Key);
           NewPos := TRUE;
          End;
        End;

      End;

    End;

  End;

 { Virer l'emulateur }

 Dispose(E2.Ram);
 E2.Ram := NIL;
 If E2.DRCS<>NIL Then
  Begin
   Dispose(E2.DRCS);
   E2.DRCS := NIL;
  End;

 If (Quit) Then ShowPage := $FFFF
 Else ShowPage := cont;
End;



Type PathStr = String[20];
     PPathStr = ^PathStr;

Const MaxName = 8192;
Var TabName : Array[1..MaxName] Of PPathStr;
    NbName : Word;

Function AddFileName( Name : String ) : Boolean;
Var i : Word;
    n : PPathStr;
Begin
 If NbName<MaxName Then
  Begin
   For i := 1 To NbName Do
    If TabName[i]^=Name Then
     Begin
      AddFileName := TRUE;
      Exit;
     End;
   New(n);
   If (n<>NIL) Then
    Begin
     n^ := Name;
     Inc(NbName);
     TabName[NbName] := n;
     AddFileName := TRUE;
     Exit;
    End;
  End;
 AddFileName := FALSE;
End;



Procedure Go( Var Rep : String );
Var SaveProc, SaveUp : Pointer;
    i : Word;
    Quit : Boolean;
    next : Word;
Begin

 InstallC18;

 CheckBreak := FALSE;

 SaveProc := RamProc.Ptr;
 RamProc.Proc := EmulToScreen;

 SaveUp := ScrollProc.Ptr;
 ScrollProc.Proc := EmulToScreenScroll;

 VideoInit;

 PresenteSoft;


 i := 1;

 While TRUE Do
  Begin
   If (i<=0) Then i := NbName
   Else If (i>NbName) Then i := 1;

   next := ShowPage(i,NbName,Rep,TabName[i]^,TRUE);
   If (next=$FFFF) Then Break;

   i := next;
  End;


 VideoDone;

 ScrollProc.Ptr := SaveUp;
 RamProc.Ptr := SaveProc;

End;

Function loading( Var Rep : String ) : Boolean;
Var npar : Word;
    DirInfo : SearchRec;
    n    : NameStr;
    ext  : ExtStr;
    i    : Word;
Begin
 NbName := 0;

 For npar := 1 To ParamCount Do
  Begin
   FindFirst(ParamStr(npar),Archive,DirInfo);
   FSplit(ParamStr(npar),rep,n,ext);
   For i := 1 To Length(rep) Do rep[i] := UpCase(rep[i]);

   While DosError=0 Do
    Begin
     If Not(AddFileName(DirInfo.Name)) Then
      Begin
       Writeln('*** Trop de fichiers  traiter !');
       loading := FALSE;
       Exit;
      End;
     FindNext(DirInfo);
    End;
   If (DosError<>18) And (DosError<>0) Then
    Begin
     Writeln('*** Erreur DOS n ',DOSError);
     loading := FALSE;
     Exit;
    End;
  End;

 loading := TRUE;
End;

Procedure Start;
Var rep : String;
Begin
 if loading(rep) Then
  If (NbName>0) Then Go(rep)
  Else Writeln('Pas de pages a afficher!');
End;

Begin
 If (ParamCount=0) Then
  Begin
   Writeln('VTEX v1.1b (C) TJ');
   Writeln('');
   Writeln('  VTEX nom');
   Writeln('');
  End
 Else Start;
End.

